function fldcmp(mr,fdnum)

fieldmodal=mr.FieldDetectors{fdnum}.FieldModal;
nmode=mr.ModeNumber;
twonmode=2*nmode;
twonmode1=twonmode+1;

L=mr.LayerNumber;

Thickness=zeros(L,1);
for icount=1:L
    Thickness(icount)=mr.Layers{icount}.Thickness;
end

x=mr.FieldDetectors{fdnum}.X+mr.Period/2;
% since the definition of x in the rcwate and rcwatm codes are mr.Period/2
% off the original point
z=mr.FieldDetectors{fdnum}.Z;
xresol=mr.FieldDetectors{fdnum}.XResolution;
zresol=mr.FieldDetectors{fdnum}.ZResolution;
zlayer=zeros(zresol,1);

n1=mr.Layers{1}.IndexProfile(1);
incidentangle=mr.LightSource.IncidentAngle;
k0=mr.ComputingResults.k0;
kx=mr.ComputingResults.kx;
kz1=mr.ComputingResults.kz1;
kzL=mr.ComputingResults.kzL;
R=mr.ComputingResults.R;
T=mr.ComputingResults.T;
CP=mr.ComputingResults.CP;
CM=mr.ComputingResults.CM;
W=mr.ComputingResults.W;
q=mr.ComputingResults.q;

layerpointer=1;
for icount=1:zresol
    while (z(icount)>Thickness(layerpointer)) && (layerpointer<L)
        layerpointer=layerpointer+1;
    end
    zlayer(icount)=layerpointer;
    % zlayer records the layer number of each of the z pixel
end
zlayerdivider=find(diff(zlayer));

xx=x(:,ones(length(z),1));
zz=z(:,ones(length(x),1))';
Ey=zeros(xresol,zresol);
for icount=1:length(zlayerdivider)+1
    if icount==length(zlayerdivider)+1 && icount~=1
        currentlayer=zlayer(end);
        if isempty(zlayerdivider)
            currentlayer1=1;
            % currelyaer1:currentlayer2 are the z vector index range for
            % current layer.
        else
            currentlayer1=zlayerdivider(icount-1)+1;
        end
        currentlayer2=zresol;
        if zlayer(end)==L
            for jcount=1:twonmode1
                Ey(:,currentlayer1:currentlayer2)=...
                    Ey(:,currentlayer1:currentlayer2)...
                    +T(jcount)*exp(...
                    -1i*(kx(jcount)...
                    *xx(:,currentlayer1:currentlayer2)...
                    +kzL(jcount)...
                    *(zz(:,currentlayer1:currentlayer2)...
                    -Thickness(L-1))));
            end
        else
            for jcount=1:twonmode1
                for kcount=1:twonmode1
                    Ey(:,currentlayer1:currentlayer2)=...
                    Ey(:,currentlayer1:currentlayer2)...
                    +W(jcount,kcount,currentlayer)...
                    *(CP(kcount,currentlayer)...
                    *exp(-k0*q(kcount,currentlayer)...
                    *(zz(:,currentlayer1:currentlayer2)...
                    -Thickness(currentlayer-1)))...
                    +CM(kcount,currentlayer)...
                    *exp(k0*q(kcount,currentlayer)...
                    *(zz(:,currentlayer1:currentlayer2)...
                    -Thickness(currentlayer))))...
                    .*exp(-1i*kx(jcount)...
                    *xx(:,currentlayer1:currentlayer2));
                end
            end
        end
    elseif icount==1
        if isempty(zlayerdivider)
            currentlayer=zlayer(1);
            currentlayer2=zresol;
        else
            currentlayer=zlayer(zlayerdivider(icount));
            currentlayer2=zlayerdivider(icount);
        end
        currentlayer1=1;
        if zlayer(1)==1
            if strcmp(fieldmodal,'total')
                Ey(:,currentlayer1:currentlayer2)=...
                    exp(-1i*k0*n1*(sind(incidentangle)...
                    *xx(:,currentlayer1:currentlayer2)...
                    +cosd(incidentangle)...
                    *zz(:,currentlayer1:currentlayer2)));
            end
            for jcount=1:twonmode1
                Ey(:,currentlayer1:currentlayer2)=...
                    Ey(:,currentlayer1:currentlayer2)...
                    +R(jcount)*exp(...
                    -1i*(kx(jcount)...
                    *xx(:,currentlayer1:currentlayer2)...
                    -kz1(jcount)*zz(:,currentlayer1:currentlayer2)));
            end
        else
            for jcount=1:twonmode1
                for kcount=1:twonmode1
                    Ey(:,currentlayer1:currentlayer2)=...
                    Ey(:,currentlayer1:currentlayer2)...
                    +W(jcount,kcount,currentlayer)...
                    *(CP(kcount,currentlayer)...
                    *exp(-k0*q(kcount,currentlayer)...
                    *(zz(:,currentlayer1:currentlayer2)...
                    -Thickness(currentlayer-1)))...
                    +CM(kcount,currentlayer)...
                    *exp(k0*q(kcount,currentlayer)...
                    *(zz(:,currentlayer1:currentlayer2)...
                    -Thickness(currentlayer))))...
                    .*exp(-1i*kx(jcount)...
                    *xx(:,currentlayer1:currentlayer2));
                end
            end
        end
    else
        currentlayer=zlayer(zlayerdivider(icount));
        currentlayer1=zlayerdivider(icount-1)+1;
        currentlayer2=zlayerdivider(icount);    
        for jcount=1:twonmode1
            for kcount=1:twonmode1
                Ey(:,currentlayer1:currentlayer2)=...
                Ey(:,currentlayer1:currentlayer2)...
                +W(jcount,kcount,currentlayer)...
                *(CP(kcount,currentlayer)...
                *exp(-k0*q(kcount,currentlayer)...
                *(zz(:,currentlayer1:currentlayer2)...
                -Thickness(currentlayer-1)))...
                +CM(kcount,currentlayer)...
                *exp(k0*q(kcount,currentlayer)...
                *(zz(:,currentlayer1:currentlayer2)...
                -Thickness(currentlayer))))...
                .*exp(-1i*kx(jcount)...
                *xx(:,currentlayer1:currentlayer2));
            end
        end
    end
end     
mr.FieldDetectors{fdnum}.Field=Ey;